﻿<?php
/*
Plugin Name: Around this date in the past... - Widget Edition
Plugin URI: http://www.junyent.org/blog/2006/05/20/around-this-date-in-the-past-wordpress-widget/
Description: Widget that shows entries/posts around this date in the past (if they exist)
Version: 0.6.3
Author: Joan Junyent Tarrida
Contributors: jjunyent, Mike Koepke, Cinefilo
Author URI: http://www.junyent.org/

[ Notas en castellano en la web ]  [  Notes en catal� a la web ]

== English notes ==

This plugin is based on:
	- "One year ago" plugin released by Borja Fernandez.  [  http://www.lamateporunyogur.net/wp-plugins/one-year-ago/  ]  [  http://www.lamateporunyogur.net  ] 
	- "Wayback" plugin released by Chris Goringe.  [  http://code.goringe.net/WordPress/ ]  [  http://tis.goringe.net  ]  
	- "Wayback Widget" released by Sven Weidauer. [ http://dergraf.net/computer/wordpress/wayback-widget/  ] [ http://dergraf.net/  ]
	- My plugin Around this date in the past. [ http://www.junyent.org/blog/arxius/2006/05/20/around-this-date-in-the-past-wordpress-plugin/  ] 

Description

	It shows around this date entries/posts in the past (if they exist). By default it retreives a week around the current day X years ago.

Parameters
	$title = T�tle of the widget. By default "This week last year...: "
	$daysbefore = Days' posts that will show before one year ago. By default '3' (3 days before)
	$daysafter = Days' posts that will show after one year ago. By default '3' (3 days after)
	$mode = Select the mode that you want the widget to work. By default '1' (X years ago)
		Mode 1: get posts around this date from X years ago.
		Mode 2: get posts around this date for the last X years.
		Mode 3: get posts around this date since year X.
	$yearsago = It shows 'X' years ago posts. By default '1' (1 year). ONLY IF MODE 1 IS SELECTED.
	$lastxyears = It shows posts por the last "X" years. By default '1' (1 year). ONLY IF MODE 2 IS SELECTED.
	$sinceyear = It shows posts since the year "X". By default '2005' (since year 2005). ONLY IF MODE 3 IS SELECTED.
	$limit = Number of posts to retrieve. By default '4'.
	$none = Text shown when there are no posts. By default 'none'. 
 

Use

	You can set the parameters from the widgets panel
	
License

	This plugin is free software; you can redistribute it and/or modify (without commercial purposes) it under the terms of the Creative Commons License (don't remove credits to author, please)
	You can view the full text of the license here: http://creativecommons.org/licenses/by-nc/2.5/

	
Installing

	1. Once downloaded the file, change the file extension from .phps to .php
	2. Upload it through FTP to the server where your Wordpress blog is hosted.
	3. Copy it to the folder /wp-content/plugins/ (you can also copy it to /wp-content/plugins/widgets/ in order to have all the widegts together) .
	4. Activate it through the plugin management screen.
	5. Go to "Themes" > "Sidebar Widgets" and drag and drop the widget wherever you want to show it.

Changelog
	v.0.6.3 = Fixed a bug when calling get_old_posts().
	v.0.6.2 = Fixed a bug when having  &amp; in post's title. Isolated repetitive code in its own function. Changes contributed by Mike Koepke. 
	v.0.6.1 = Fixed bug when having quotes in post's title. Thanks to Mike Koepke for bug repporting and helping with fixing.
	v0.6 = Added 2 new modes, last X years and since year X. 
		Corrected bug in $start_ago and $end_ago.
	v0.5.2 = XHTML valid. Luís Pérez (aka Cinéfilo)
	v0.5.1 = Now the $yearsago parameter works.
	v0.5.01 = Now the limit option works, for real ;)
	v0.5 = First release. I decided to start on version 0.5 because of preserving version relation with �One year ago� plugin.

Thanks

	Thanks to Borja Fernandez, Chris Goringe and Sven Weidauer for writing their plugins and to Luis P�rez and Mike Koepke for their contributions.
	
	
*/

function around_this_date ( $daysbefore = '3', $daysafter = '3', $mode = '1', $yearsago = '1', $lastxyears= '1', $sinceyear='2006', $limit = '4', $none = 'none') 
{
		
	if ($mode == '1') {  // "classic" mode
	
		$start_ago = (365*$yearsago)+$daysbefore;
		$end_ago = (365*$yearsago)-$daysafter;
		
		get_old_posts( $start_ago, $end_ago, $limit, $none);
	}
	elseif ($mode == '2') { // last x years mode
	
		for($year = 1; $year <= $lastxyears; $year++) {
		
			$start_ago = (365*$year)+$daysbefore;
			$end_ago = (365*$year)-$daysafter;
			
			get_old_posts( $start_ago, $end_ago, $limit, $none);
		}
	}
	elseif ($mode == '3') { // since year x mode
	
		for($year = 1; $year <= (date("Y")-$sinceyear); $year++) {

			$start_ago = (365*$year)+$daysbefore;
			$end_ago = (365*$year)-$daysafter;
			
			get_old_posts( $start_ago, $end_ago, $limit, $none);
		}
	}
}

function get_old_posts( $start_ago, $end_ago, $limit, $none )
{
	global $wpdb;

	$entries = $wpdb->get_results ("SELECT " .
				  "ID, post_title " .
				  "FROM $wpdb->posts " .
				  " WHERE post_status = 'publish' AND (( TO_DAYS( NOW() ) - TO_DAYS( post_date ) ) BETWEEN " . $end_ago . " AND " . $start_ago . ")".
				  " ORDER by 'asc'" .
				  " LIMIT $limit"
					);
							
	print "<ul>";
	if ($entries) {
		$output = ''; // empty the 'output' string
		foreach ($entries as $entry) {
			$title = str_replace('"', '',$entry->post_title);
			$title = htmlspecialchars($title);						
			$output .= '<li><a href="'.get_permalink($entry->ID).'" rel="bookmark" title="Permanent link to '.$title.'">'. htmlspecialchars($entry->post_title) .'</a></li>';
		}
		print "$output";
	}
	else {
		print('<li>' .$none. '</li>');	
	}
	print "</ul>";
}
	
function widget_atd_init()
{
	if (!function_exists('register_sidebar_widget')) return;
	
	function widget_atd( $args )
	{
		extract( $args );
		$options = get_option( 'widget_atd' );
		$title = $options['title'];
		
		$daysbefore = $options['daysbefore'];
		$daysafter = $options['daysafter'];
		
		$mode = $options['mode'];
		
		$yearsago = $options['yearsago'];
		$sinceyear = $options['sinceyear'];
		$lastxyears = $options['lastxyears'];
		
		$limit = $options['limit'];
		$none = $options['none'];

		echo $before_widget . $before_title . $title . $after_title;
		around_this_date( $daysbefore, $daysafter, $mode, $yearsago, $lastxyears, $sinceyear, $limit, $none );
		echo $after_widget;
	}
	
	function widget_atd_control()
	{
		$options = get_option( 'widget_atd' );
		if (!is_array( $options )) {
			$options = array( 'title' => 'This week last year...',
				'daysbefore' => 3, 'daysafter' => 3, 'mode' => 1, 'yearsago' => 1, 'lastxyears' => 1, 'sinceyear' => 2005, 'limit' => 4, 'none' => 'none');
		}
		
		if ($_POST['atd-submit']) {
			$options['title'] = strip_tags(stripslashes($_POST['atd-title']));
			$options['daysbefore'] = strip_tags(stripslashes($_POST['atd-daysbefore']));
			$options['daysafter'] = strip_tags(stripslashes($_POST['atd-daysafter']));
			$options['mode'] = strip_tags(stripslashes($_POST['atd-mode']));
			$options['yearsago'] = strip_tags(stripslashes($_POST['atd-yearsago']));
			$options['sinceyear'] = strip_tags(stripslashes($_POST['atd-sinceyear']));
			$options['lastxyears'] = strip_tags(stripslashes($_POST['atd-lastxyears']));
			$options['limit'] = strip_tags(stripslashes($_POST['atd-limit']));
			$options['none'] = strip_tags(stripslashes($_POST['atd-none']));

			
			update_option( 'widget_atd', $options );
		}
		
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$daysbefore = htmlspecialchars($options['daysbefore'], ENT_QUOTES);
		$daysafter = htmlspecialchars($options['daysafter'], ENT_QUOTES);
		$mode = htmlspecialchars($options['mode'], ENT_QUOTES);
		$yearsago = htmlspecialchars($options['yearsago'], ENT_QUOTES);
		$sinceyear = htmlspecialchars($options['sinceyear'], ENT_QUOTES);
		$lastxyears = htmlspecialchars($options['lastxyears'], ENT_QUOTES);
		$limit = htmlspecialchars($options['limit'], ENT_QUOTES);
		$none = htmlspecialchars($options['none'], ENT_QUOTES);

		?>
				<label>Title : <input type="text" id="atd-title" name="atd-title" size="45" value="<?php echo $title ?>" /></label><br />
				<label>Days before : <input type="text" id="atd-daysbefore" name="atd-daysbefore" size="10" value="<?php echo $daysbefore ?>" /></label><br />
				<label>Days after : <input type="text" id="atd-daysafter" name="atd-daysafter" size="10" value="<?php echo $daysafter ?>" /></label><br />
				<label>Limit of entries : <input type="text" id="atd-limit" name="atd-limit" size="10" value="<?php echo $limit ?>" /></label><br />
				<label>Text when no entries: <input type="text" id="atd-none" name="atd-none" size="45" value="<?php echo $none ?>" /></label><br />
				<br />
				<label>Select Mode: <input type="text" id="atd-mode" name="atd-mode" size="10px" value="<?php echo $mode ?>" /></label><br />
					<ul>
						<li>mode 1: get posts around this date from X years ago.</li>
						<li>mode 2: get posts around this date from the last X years.</li>
						<li>mode 3: get posts around this date since year X.</li>
					</ul>
				<br />
				Mode Options:
					<ul>
						<li><label>X Years ago &nbsp;&nbsp;(only if mode 1 is selected) : <input type="text" id="atd-yearsago" name="atd-yearsago" size="10" value="<?php echo $yearsago ?>" /></label></li>
						<li><label>Last X years &nbsp;(only if mode 2 is selected) : <input type="text" id="atd-lastxyears" name="atd-lastxyears" size="10" value="<?php echo $lastxyears ?>" /></label></li>
						<li><label>Since year X &nbsp;(only if mode 3 is selected) : <input type="text" id="atd-sinceyear" name="atd-sinceyear" size="10" value="<?php echo $sinceyear ?>" /></label></li>
					</ul>	
										
			<input type="hidden" id="atd-submit" name="atd-submit" value="1" />
		<?php
	}
	
	register_sidebar_widget( 'Around this date', 'widget_atd' );
	register_widget_control( 'Around this date', 'widget_atd_control', 400, 400 );
}

add_action( 'plugins_loaded', 'widget_atd_init' );

?>
